package tofly.opc_gateway;

import javax.annotation.PostConstruct;
import javax.swing.*;
import java.awt.*;
import java.net.URL;

//@Component
public class SystemTrayIcon extends TrayIcon {

    private static final String IMAGE_PATH = "/tray.png";
    private static final String TOOLTIP = "同飞OPC数据采集中...";

    private PopupMenu popup;
    private SystemTray tray;

    public SystemTrayIcon(){
        super(createImage(IMAGE_PATH,TOOLTIP),TOOLTIP);
        popup = new PopupMenu();
        tray = SystemTray.getSystemTray();
    }

    @PostConstruct
    private void setup() throws AWTException{
        MenuItem exitItem = new MenuItem("退出");
        exitItem.addActionListener((e)->{
            System.exit(0);
        });
        popup.add(exitItem);
        popup.addSeparator();
        MenuItem aboutItem = new MenuItem("关于");
        popup.add(aboutItem);
        // here add the items to your popup menu. These extend MenuItem

        setPopupMenu(popup);
        tray.add(this);
    }

    protected static Image createImage(String path, String description){
        URL imageURL = SystemTrayIcon.class.getResource(path);
        if(imageURL == null){
            System.err.println("Failed Creating Image. Resource not found: "+path);
            return null;
        }else {
            return new ImageIcon(imageURL,description).getImage();
        }
    }
}